# DemoVIPS
This project encapsulates VIPS into a single Docker container, a VIPS at a snapshot in time. For demonstration purposes. It stays at the same date indefinately, so that you have a consistent view of VIPS

Subsystems included:
* VIPSWeb
* VIPSLogic with database
* VIPSCore with a selection of VIPS Models

**External services dependencies**: The container expects these "static" risk map WMSs to be available
* Carrot rust fly risk map: https://gridweb.vips.nibio.no/cgi-bin/PSILARTEMP_DEMO?service=WMS&version=1.3.0&request=GetCapabilities&language=nb
* Naerstad's potato late blight model risk map: https://gridweb.vips.nibio.no/cgi-bin/NAERSTADMO_DEMO?service=WMS&version=1.3.0&request=GetCapabilities&language=nb


# Configuring
## DemoVIPS date
The date is set when running the container (see below).

## Building
You need [Docker installed](https://docs.docker.com/engine/install/) to build DemoVIPS. 

You must dump the VIPSLogic database from your preferred source like this

```
pg_dumpall | gzip > vipslogic.sql.gz
```

...and place it in the project folder

The building of the image takes quite a lot of time, since there's a lot of code that needs to be build with Maven.

```bash
$ sudo docker build --tag demovips:1.0 .
```

# Running
Run the container for the first time like this

```bash
$ sudo docker run --publish 18080:80 --detach --name demovips -e SYSTEM_TIME_EXACT_DATE=2023-07-01 demovips:1.0
```
...where SYSTEM_TIME_EXACT_DATE is the date that you want DemoVIPS to be stuck in.

Skip the `--detach` if you want to see the output when the container is booting. On the first run of the container, the database is imported and cache tables need to be initalized, which can take 5-10 minutes. Please be patient. When the container is ready, DemoVIPS is visible on `http://localhost:18080/`

Subsequent startups of the container can be done like this:

```bash
$ sudo docker start demovips
```